autowatch = 1

/*

	conversion of a jitter matrix to an audio buffer
	adapted to flucoma STFT format
	target buffer must be provided as argument
	
*/

if(jsarguments.length>1) // argument 0 is the name of the js file
{
   var b = new Buffer(jsarguments[1]);
   post("target buffer:", jsarguments[1], "\n");
   post("number of channels:", b.channelcount(), "\n");
   post("number of samples per channel:", b.framecount(), "\n");
   var type;
   if (jsarguments == "p") type = 1;
   else type = 0;
}

function test() {
	for(var chan = 0; chan < 513; chan++) {
		for(var frame = 0;  frame < 513; frame++) {
			b.poke(chan+1, frame, Math.random());
		}
	}
}

// data from matrixes are supposed to have lower bins in bottom of the picture
// it means the lower bins are on top of the y axis

function jit_matrix(name) {
	var mtx = new JitterObject("jit.matrix", name);
	// iteration on the x axis of the matrix - translated to the frame in the sound buffer
	for(var xToFrame = 0; xToFrame < 512; xToFrame++) {
		// iteration on the y axis- translated to the bin/channel in the buffer
			for(var yToChan = 0;  yToChan < 512; yToChan++) {
				var val = mtx.getcell(xToFrame,yToChan);
				b.poke(513-yToChan-1, xToFrame, val);
			}
			if (type == 1) b.poke(513, xToFrame, 0.5); //Nyquist band - phase
			else b.poke(513, xToFrame, 0.); //Nyquist band - magnitude
	} 
	outlet(0, "bang")
}

