autowatch = 1

/*
	conversion of an audio buffer to a matrix
	for output buffers of fluid.STFT object
	
*/

function buffer(x) {
	var b = new Buffer(x);
	var frames = b.framecount();
	var chans = b.channelcount();
	
	//post("framecount of buffer:", frames, "\n");
	//post("frames in buffer:", frames, "\n");
	//post("channels in buffer:", chans, "\n");
	
	var matrix = new JitterMatrix(1, "float32", 512, 512)
	// iteration through frames - converted to x axis of the Jitter matrix
	for (var frameToX=0; frameToX<chans-1; frameToX++){
		// iteration through channels - converted to y axis of the matrix but with inversion
		for (var chanToY=0; chanToY<frames; chanToY++){
				var v = b.peek(chanToY+1,frameToX,1);	
				matrix.setcell2d(frameToX, 511-chanToY, v);
		}
	}

	outlet(0, "jit_matrix", matrix.name)
}